package com.kmalbz.api.route

import com.kmalbz.database.service.IInputObjectService
import io.ktor.application.call
import io.ktor.http.HttpStatusCode
import io.ktor.response.respond
import io.ktor.routing.Routing
import io.ktor.routing.get
import io.ktor.routing.post
import org.koin.ktor.ext.inject

/**
 * Input Service
 * 
 * This is the input interface of the Birbnetes system.
 */
class InputServiceServer {
    /**
     * sample
     */
    fun Routing.registerOutput() {
        val resultObjectService by inject<IInputObjectService>()
        get("/sample"){
            call.respond(resultObjectService.getAllInputObjects())
        }

        post("/sample"){
            call.respond(resultObjectService.getAllInputObjects())
        }

        get("/sample/{tagID}") {
            val tagID = call.parameters["tagID"] ?: error(HttpStatusCode.NotAcceptable)
            val resultObject = resultObjectService.getInputObjectbyTag(tagID) ?: call.respond(HttpStatusCode.NotFound)

            call.respond(resultObject)
        }
    }
}
